/* ---------------------------------------------------------------------------- */
/* Camera                                                                       */
/* ---------------------------------------------------------------------------- */

/* Implémentation d'une trackball caméra.                                       */

class Camera {
  double phi = PI / 4;
  double theta = 0;
  PVector direction;
  PVector normal;
  PVector center;
  
  float last_mouseX;
  float last_mouseY;
  boolean is_active = false;
  
  Camera(float distance) {
    direction = new PVector(0, 0, distance);
    normal = new PVector(0, 1, 0);
    center = new PVector(width/2, height/2, 0);
  }
  
  private float move_angle(float move) {
    return (TWO_PI * move) / max(width, height);
  }
  
  void active() {
    last_mouseX = mouseX;
    last_mouseY = mouseY;
    is_active = true;
  }
  
  void unactive() {
    theta += move_angle(mouseX - last_mouseX);
    phi += move_angle(mouseY - last_mouseY);
    is_active = false;
  }
  
  void zoom(float val) {
    direction.mult(val);
  }
  
  void look() {
    float tmp_theta = (float)theta;
    float tmp_phi = (float)phi;
    if(is_active) {
      tmp_theta += move_angle(mouseX - last_mouseX);
      tmp_phi += move_angle(mouseY - last_mouseY);
    }
    PVector eye = PVector.sub(center, direction);
    PVector n = normal;
    camera(eye.x, eye.y, eye.z, center.x, center.y, center.z, n.x, n.y, n.z);
    translate(width/2, height/2);
    rotateX(tmp_phi);
    rotateY(tmp_theta);
  }
}
